import React from 'react';
import { TreeTableProps, TreeTableRef } from './types';
import './TreeTable.css';
export declare const TreeTable: React.ForwardRefExoticComponent<TreeTableProps<any> & React.RefAttributes<TreeTableRef<any>>>;
export declare function resolveProps(props: TreeTableProps): {
    plugins: import("./types").TreeTablePlugin<any>[];
    indentSize: number;
    headDataIndex: string;
    childrenColumnName: string;
    rowKey: string;
    dataSource: any[];
    columns: import("antd").TableColumnType<any>[];
    disableIndentLine?: boolean;
    dropdownPrefixCls?: string;
    pagination?: false | import("antd").TablePaginationConfig;
    loading?: boolean | import("antd").SpinProps;
    size?: import("antd/lib/button").ButtonSize;
    bordered?: boolean;
    locale?: import("antd/lib/table/interface").TableLocale;
    onChange?: (pagination: import("antd").TablePaginationConfig, filters: Record<string, import("antd/lib/table/interface").FilterValue>, sorter: import("antd/lib/table/interface").SorterResult<any> | import("antd/lib/table/interface").SorterResult<any>[], extra: import("antd/lib/table/interface").TableCurrentDataSource<any>) => void;
    rowSelection?: import("antd/lib/table/interface").TableRowSelection<any>;
    getPopupContainer?: import("antd/lib/table/interface").GetPopupContainer;
    scroll?: {
        x?: string | number | true;
        y?: string | number;
    } & {
        scrollToFirstRowOnChange?: boolean;
    };
    sortDirections?: import("antd/lib/table/interface").SortOrder[];
    showSorterTooltip?: boolean | import("antd").TooltipProps;
    expandedRowKeys?: React.Key[];
    defaultExpandedRowKeys?: React.Key[];
    expandedRowRender?: import("rc-table/lib/interface").ExpandedRowRender<any>;
    expandRowByClick?: boolean;
    expandIcon?: import("rc-table/lib/interface").RenderExpandIcon<any>;
    onExpand?: (expanded: boolean, record: any) => void;
    onExpandedRowsChange?: (expandedKeys: React.Key[]) => void;
    defaultExpandAllRows?: boolean;
    expandIconColumnIndex?: number;
    expandedRowClassName?: import("rc-table/lib/interface").RowClassName<any>;
    prefixCls?: string;
    className?: string;
    style?: React.CSSProperties;
    children?: React.ReactNode;
    tableLayout?: import("rc-table/lib/interface").TableLayout;
    expandable?: import("rc-table/lib/interface").ExpandableConfig<any>;
    rowClassName?: string | import("rc-table/lib/interface").RowClassName<any>;
    title?: import("rc-table/lib/interface").PanelRender<any>;
    footer?: import("rc-table/lib/interface").PanelRender<any>;
    summary?: (data: readonly any[]) => React.ReactNode;
    id?: string;
    showHeader?: boolean;
    components?: import("rc-table/lib/interface").TableComponents<any>;
    onRow?: import("rc-table/lib/interface").GetComponentProps<any>;
    onHeaderRow?: import("rc-table/lib/interface").GetComponentProps<readonly import("rc-table/lib/interface").ColumnType<any>[]>;
    direction?: "ltr" | "rtl";
    sticky?: boolean | import("rc-table/lib/interface").TableSticky;
};
