import React, { useMemo, useReducer, useState, useImperativeHandle, useEffect } from 'react';
import { Pagination, Popover, Input, Table } from 'antd';
import { LoadingOutlined, DownOutlined, RightOutlined, FilterOutlined } from '@ant-design/icons';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

/**
 * 递归树的通用函数
 */
var traverseTree = function traverseTree(treeList, childrenColumnName, callback) {
  var traverse = function traverse(list) {
    var parent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var level = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
    list.forEach(function (treeNode) {
      callback(treeNode, parent, level);
      var next = treeNode[childrenColumnName];

      if (Array.isArray(next)) {
        traverse(next, treeNode, level + 1);
      }
    });
  };

  traverse(treeList);
};
var resolveAllExpandableKeys = function resolveAllExpandableKeys(dataSource) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$childrenColumnNa = _ref.childrenColumnName,
      childrenColumnName = _ref$childrenColumnNa === void 0 ? 'children' : _ref$childrenColumnNa,
      _ref$rowKey = _ref.rowKey,
      rowKey = _ref$rowKey === void 0 ? 'id' : _ref$rowKey;

  var keys = [];
  traverseTree(dataSource, childrenColumnName, function (node) {
    var _node$childrenColumnN;

    if (node[childrenColumnName] && // 去除掉内部用的占位节点
    !isInternalNode((_node$childrenColumnN = node[childrenColumnName]) === null || _node$childrenColumnN === void 0 ? void 0 : _node$childrenColumnN[0], rowKey)) {
      keys.push(node[rowKey]);
    }
  });
  return keys;
};
var INTERNAL_PREFIX = '__react_antd_treetable';
var createInternalConstant = function createInternalConstant(value) {
  return "".concat(INTERNAL_PREFIX, "_").concat(value);
};
var isInternalNode = function isInternalNode(record, rowKey) {
  var _record$rowKey, _record$rowKey$starts;

  return (_record$rowKey = record[rowKey]) === null || _record$rowKey === void 0 ? void 0 : (_record$rowKey$starts = _record$rowKey.startsWith) === null || _record$rowKey$starts === void 0 ? void 0 : _record$rowKey$starts.call(_record$rowKey, INTERNAL_PREFIX);
};

var INTERNAL_LOADING_KEY = createInternalConstant('loading'); // 树节点属性：标记树的等级

var INTERNAL_LEVEL = createInternalConstant('level'); // 树节点属性：标记树的父层级引用

var INTERNAL_PARENT = createInternalConstant('parent'); // 树节点属性：标记该节点正在加载更多子节点

var INTERNAL_IS_LOADING = createInternalConstant('is_loading'); // 树节点属性：标记该节点用来渲染分页器

var INTERNAL_PAGINATION_KEY = createInternalConstant('pagination');

var _excluded = ["expandIcon"];
var iconStyle = {
  width: 12,
  height: 12,
  marginRight: 8,
  marginTop: 4,
  fontSize: 12,
  flexShrink: 0
};
var TreeTableExpandIcon = function TreeTableExpandIcon(props) {
  var expandIcon = props.expandIcon,
      expandIconProps = _objectWithoutProperties(props, _excluded);

  var expanded = expandIconProps.expanded,
      expandable = expandIconProps.expandable,
      onExpand = expandIconProps.onExpand,
      record = expandIconProps.record;

  if (record[INTERNAL_IS_LOADING]) {
    return /*#__PURE__*/React.createElement(LoadingOutlined, {
      style: iconStyle
    });
  }

  if (expandIcon) {
    return expandIcon(expandIconProps);
  }

  if (expandable) {
    if (expanded) {
      return /*#__PURE__*/React.createElement(DownOutlined, {
        style: iconStyle,
        onClick: function onClick(e) {
          onExpand(record, e);
        }
      });
    } else {
      return /*#__PURE__*/React.createElement(RightOutlined, {
        style: iconStyle,
        onClick: function onClick(e) {
          onExpand(record, e);
        }
      });
    }
  } else {
    return /*#__PURE__*/React.createElement("span", {
      style: iconStyle
    });
  }
};

var INTERNAL_PAGINATION_CURRENT = createInternalConstant('pagination_current');
var isInternalPaginationNode = function isInternalPaginationNode(record, rowKey) {
  var _record$rowKey, _record$rowKey$starts;

  return record === null || record === void 0 ? void 0 : (_record$rowKey = record[rowKey]) === null || _record$rowKey === void 0 ? void 0 : (_record$rowKey$starts = _record$rowKey.startsWith) === null || _record$rowKey$starts === void 0 ? void 0 : _record$rowKey$starts.call(_record$rowKey, INTERNAL_PAGINATION_KEY);
};
var generateInternalPaginationNode = function generateInternalPaginationNode(rowKey) {
  return _defineProperty({}, rowKey, "".concat(INTERNAL_PAGINATION_KEY, "-").concat(Math.random()));
};
var usePaginationPlugin = function usePaginationPlugin(paginationOptions) {
  return function (props, context) {
    var forceUpdate = context.forceUpdate,
        replaceChildList = context.replaceChildList,
        addImperativeHandle = context.addImperativeHandle;
    var childrenColumnName = props.childrenColumnName,
        rowKey = props.rowKey,
        headDataIndex = props.headDataIndex;
    addImperativeHandle({
      setNodePage: function setNodePage(record, page) {
        record[INTERNAL_PAGINATION_CURRENT] = page;
      },
      getNodePage: function getNodePage(record) {
        return record[INTERNAL_PAGINATION_CURRENT];
      }
    });

    var handlePagination = function handlePagination(node) {
      var _nodeChildren$slice3;

      if (!node) {
        return;
      }

      var totalKey = paginationOptions.totalKey;
      var nodeChildren = node[childrenColumnName] || [];

      var _nodeChildren$slice = (_nodeChildren$slice3 = nodeChildren.slice) === null || _nodeChildren$slice3 === void 0 ? void 0 : _nodeChildren$slice3.call(nodeChildren, -1),
          _nodeChildren$slice2 = _slicedToArray(_nodeChildren$slice, 1),
          lastChildNode = _nodeChildren$slice2[0]; // 渲染分页器，先加入占位节点


      if (node[totalKey] > (nodeChildren === null || nodeChildren === void 0 ? void 0 : nodeChildren.length) && // 防止重复添加分页器占位符
      !isInternalPaginationNode(lastChildNode, rowKey)) {
        var _nodeChildren$push;

        nodeChildren === null || nodeChildren === void 0 ? void 0 : (_nodeChildren$push = nodeChildren.push) === null || _nodeChildren$push === void 0 ? void 0 : _nodeChildren$push.call(nodeChildren, generateInternalPaginationNode(rowKey));
      }
    };

    var rewritePaginationRender = function rewritePaginationRender(column) {
      var render = column.render,
          dataIndex = column.dataIndex;
      var totalKey = paginationOptions.totalKey,
          pageSize = paginationOptions.pageSize,
          onChange = paginationOptions.onChange;

      column.render = function ColumnRender(text, record) {
        var _render;

        // 分页相关信息需要从父节点身上拿
        var parentRecord = record[INTERNAL_PARENT];
        var total = parentRecord === null || parentRecord === void 0 ? void 0 : parentRecord[totalKey];

        if (isInternalPaginationNode(record, rowKey)) {
          if (dataIndex === headDataIndex) {
            var onPageChange = /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(current) {
                var childList;
                return _regeneratorRuntime().wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        // 比较 hack 的记录页码在父节点上
                        // 这样组件销毁重建以后 还能正确的展示页码
                        parentRecord[INTERNAL_PAGINATION_CURRENT] = current;
                        parentRecord[INTERNAL_IS_LOADING] = true;
                        forceUpdate();
                        _context.next = 5;
                        return onChange(current, parentRecord);

                      case 5:
                        childList = _context.sent;
                        replaceChildList(parentRecord, childList);

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function onPageChange(_x) {
                return _ref2.apply(this, arguments);
              };
            }();

            return /*#__PURE__*/React.createElement(Pagination, {
              size: "small",
              defaultCurrent: parentRecord[INTERNAL_PAGINATION_CURRENT],
              total: total,
              pageSize: pageSize,
              onChange: onPageChange
            });
          } else {
            return null;
          }
        }

        return (_render = render === null || render === void 0 ? void 0 : render(text, record)) !== null && _render !== void 0 ? _render : text;
      };
    };

    return {
      onRecord: handlePagination,
      onColumn: rewritePaginationRender
    };
  };
};

var generateInternalLoadingNode = function generateInternalLoadingNode(rowKey) {
  return _defineProperty({}, rowKey, "".concat(INTERNAL_LOADING_KEY, "-").concat(Math.random()));
};
var useLazyloadPlugin = function useLazyloadPlugin(_ref2) {
  var onLoad = _ref2.onLoad,
      hasNextKey = _ref2.hasNextKey;
  return function (props, context) {
    var childrenColumnName = props.childrenColumnName,
        rowKey = props.rowKey;
    var replaceChildList = context.replaceChildList,
        expandedRowKeys = context.expandedRowKeys,
        setExpandedRowKeys = context.setExpandedRowKeys;

    var handleNextLevelLoader = function handleNextLevelLoader(node) {
      if (node === null || node === void 0 ? void 0 : node[hasNextKey]) {
        // 树表格组件要求 next 必须是非空数组才会渲染「展开按钮」
        // 所以这里手动添加一个占位节点数组
        // 后续在 onExpand 的时候再加载更多节点 并且替换这个数组
        node[childrenColumnName] = [generateInternalLoadingNode(rowKey)];
      }
    };

    var onExpand = /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(expanded, record) {
        var originalHasNext, originalChildren, childList;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(expanded && record[hasNextKey] && onLoad)) {
                  _context.next = 18;
                  break;
                }

                originalHasNext = record[hasNextKey];
                originalChildren = record[childrenColumnName]; // 标识节点的 loading

                record[INTERNAL_IS_LOADING] = true; // 移除用来展示展开箭头的假 children

                record[childrenColumnName] = null;
                _context.prev = 5;
                _context.next = 8;
                return onLoad(record);

              case 8:
                childList = _context.sent;
                record[hasNextKey] = false;
                replaceChildList(record, childList);
                _context.next = 18;
                break;

              case 13:
                _context.prev = 13;
                _context.t0 = _context["catch"](5);
                // 加载数据错误的时候 恢复原本的节点状态
                record[hasNextKey] = originalHasNext;
                record[childrenColumnName] = originalChildren;
                setExpandedRowKeys( // @ts-ignore
                expandedRowKeys.filter(function (key) {
                  return key !== INTERNAL_LOADING_KEY;
                }));

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 13]]);
      }));

      return function onExpand(_x, _x2) {
        return _ref3.apply(this, arguments);
      };
    }();

    return {
      onRecord: handleNextLevelLoader,
      onExpand: onExpand
    };
  };
};

var IndentCell = function IndentCell(props) {
  var _record$INTERNAL_PARE;

  var headDataIndex = props.headDataIndex,
      children = props.children,
      record = props.record,
      dataIndex = props.dataIndex,
      rowKey = props.rowKey,
      expandedRowKeys = props.expandedRowKeys,
      indentSize = props.indentSize,
      className = props.className;
  var isParentExpanded = expandedRowKeys.includes(record === null || record === void 0 ? void 0 : (_record$INTERNAL_PARE = record[INTERNAL_PARENT]) === null || _record$INTERNAL_PARE === void 0 ? void 0 : _record$INTERNAL_PARE[rowKey]);

  if (dataIndex !== headDataIndex || !isParentExpanded) {
    return /*#__PURE__*/React.createElement("td", {
      className: className
    }, /*#__PURE__*/React.createElement("div", {
      className: "react-antd-treetable-cell-content"
    }, children));
  } // 只有当前是展示指引线的列 且父节点是展开节点 才会展示缩进指引线
  // 只要知道层级 就知道要在 td 中绘制几条垂直指引线 举例来说：
  // 第 2 层： | | text
  // 第 3 层： | | | text


  var level = record[INTERNAL_LEVEL]; // eslint-disable-next-line

  var indent = useMemo(function () {
    var indents = [];

    for (var index = 1; index < level; index++) {
      indents.push(index * indentSize);
    }

    return indents.map(function (indent) {
      return /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'absolute',
          left: indent,
          top: 0,
          bottom: 0,
          width: 1,
          height: '100%',
          backgroundColor: '#e8e8e8'
        },
        key: indent
      });
    }); // eslint-disable-next-line
  }, [level]);
  return /*#__PURE__*/React.createElement("td", {
    className: "".concat(className, " react-antd-treetable-cell")
  }, indent, /*#__PURE__*/React.createElement("div", {
    className: "react-antd-treetable-cell-content"
  }, children));
};

var useIndentLinePlugin = function useIndentLinePlugin(props, context) {
  var expandedRowKeys = context.expandedRowKeys;

  var onColumn = function onColumn(column) {
    column.onCell = function (record) {
      return _objectSpread2({
        record: record
      }, column);
    };
  };

  var components = {
    body: {
      cell: function cell(cellProps) {
        return /*#__PURE__*/React.createElement(IndentCell, _objectSpread2(_objectSpread2(_objectSpread2({}, props), cellProps), {}, {
          expandedRowKeys: expandedRowKeys
        }));
      }
    }
  };
  return {
    components: components,
    onColumn: onColumn
  };
};

var INTERNAL_SEARCH_KEY = createInternalConstant('search_value');
var useFilterPlugin = function useFilterPlugin(onFetch) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (props, context) {
    var _options$filterDataIn = options.filterDataIndex,
        filterDataIndex = _options$filterDataIn === void 0 ? props.headDataIndex : _options$filterDataIn,
        popover = options.popover,
        _options$placeholder = options.placeholder,
        placeholder = _options$placeholder === void 0 ? '' : _options$placeholder,
        _options$highlightIco = options.highlightIconColor,
        highlightIconColor = _options$highlightIco === void 0 ? '#40a9ff' : _options$highlightIco,
        enable = options.enable;
    var addImperativeHandle = context.addImperativeHandle;
    addImperativeHandle({
      getNodeSearchKey: function getNodeSearchKey(record) {
        return record === null || record === void 0 ? void 0 : record[INTERNAL_SEARCH_KEY];
      }
    });

    var onColumn = function onColumn(column) {
      var dataIndex = column.dataIndex,
          render = column.render; // 负责展示筛选按钮的父节点

      if (dataIndex === filterDataIndex) {
        column.render = function (text, record, index) {
          var _context$expandedRowK, _render;

          var onSearch = /*#__PURE__*/function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(event) {
              var value, result;
              return _regeneratorRuntime().wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      value = event.target.value;
                      record[INTERNAL_SEARCH_KEY] = value;
                      context.setNodeLoading(record, true);
                      _context.next = 5;
                      return onFetch(record, value);

                    case 5:
                      result = _context.sent;
                      context.replaceChildList(record, result);
                      context.setNodeLoading(record, false);

                    case 8:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            }));

            return function onSearch(_x) {
              return _ref.apply(this, arguments);
            };
          }();

          var children = record[props.childrenColumnName],
              key = record[props.rowKey];
          var token = record[INTERNAL_SEARCH_KEY];
          var defaultShowFilter = token || // @ts-ignore
          ((_context$expandedRowK = context.expandedRowKeys) === null || _context$expandedRowK === void 0 ? void 0 : _context$expandedRowK.includes(key)) && (children === null || children === void 0 ? void 0 : children.length);
          var showFilter = enable ? enable(record) : defaultShowFilter;
          return /*#__PURE__*/React.createElement("div", {
            className: "react-antd-treetable-filter-cell"
          }, (_render = render === null || render === void 0 ? void 0 : render(text, record, index)) !== null && _render !== void 0 ? _render : text, showFilter ? /*#__PURE__*/React.createElement(Popover, _objectSpread2({
            content: function content() {
              return /*#__PURE__*/React.createElement(Input, {
                defaultValue: token,
                onBlur: onSearch,
                onPressEnter: onSearch,
                placeholder: placeholder
              });
            },
            title: "\u8BF7\u641C\u7D22\u5B50\u8282\u70B9",
            trigger: "click",
            placement: "bottom"
          }, popover), /*#__PURE__*/React.createElement(FilterOutlined, {
            style: {
              color: !!token ? highlightIconColor : 'inherit',
              cursor: 'pointer',
              marginLeft: 8
            }
          })) : null);
        };
      }
    };

    return {
      onColumn: onColumn
    };
  };
};

var INTERNAL_EMPTY_KEY = createInternalConstant('empty');

var isInternalEmptyNode = function isInternalEmptyNode(record, rowKey) {
  var _record$rowKey, _record$rowKey$starts;

  return record === null || record === void 0 ? void 0 : (_record$rowKey = record[rowKey]) === null || _record$rowKey === void 0 ? void 0 : (_record$rowKey$starts = _record$rowKey.startsWith) === null || _record$rowKey$starts === void 0 ? void 0 : _record$rowKey$starts.call(_record$rowKey, INTERNAL_EMPTY_KEY);
};

var generateInternalEmptyNode = function generateInternalEmptyNode(rowKey) {
  return _defineProperty({}, rowKey, "".concat(INTERNAL_EMPTY_KEY, "_").concat(Math.random()));
};

var useEmptyPlugin = function useEmptyPlugin(EmptyNode) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (props) {
    var _options$emptyNodeInd = options.emptyNodeIndex,
        emptyNodeIndex = _options$emptyNodeInd === void 0 ? props.headDataIndex : _options$emptyNodeInd;
    var childrenColumnName = props.childrenColumnName,
        rowKey = props.rowKey;

    var onRecord = function onRecord(record) {
      var children = record[childrenColumnName];

      if (Array.isArray(children) && children.length === 0) {
        children.push(generateInternalEmptyNode(rowKey));
      }
    };

    var onColumn = function onColumn(column) {
      var dataIndex = column.dataIndex,
          render = column.render; // 负责展示筛选按钮的父节点

      column.render = function (text, record, index) {
        var _render;

        if (isInternalEmptyNode(record, rowKey)) {
          if (dataIndex === emptyNodeIndex) {
            return EmptyNode;
          } else {
            return null;
          }
        }

        return (_render = render === null || render === void 0 ? void 0 : render(text, record, index)) !== null && _render !== void 0 ? _render : text;
      };
    };

    return {
      onRecord: onRecord,
      onColumn: onColumn
    };
  };
};

var usePluginContainer = function usePluginContainer(props, context) {
  var rawPlugins = props.plugins;
  var plugins = rawPlugins.map(function (usePlugin) {
    return usePlugin === null || usePlugin === void 0 ? void 0 : usePlugin(props, context);
  }).filter(Boolean);
  var container = {
    onColumn: function onColumn(column) {
      var _iterator = _createForOfIteratorHelper(plugins),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _plugin$onColumn;

          var plugin = _step.value;
          plugin === null || plugin === void 0 ? void 0 : (_plugin$onColumn = plugin.onColumn) === null || _plugin$onColumn === void 0 ? void 0 : _plugin$onColumn.call(plugin, column);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    },
    onRecord: function onRecord(record, parentRecord, level) {
      var _iterator2 = _createForOfIteratorHelper(plugins),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _plugin$onRecord;

          var plugin = _step2.value;
          plugin === null || plugin === void 0 ? void 0 : (_plugin$onRecord = plugin.onRecord) === null || _plugin$onRecord === void 0 ? void 0 : _plugin$onRecord.call(plugin, record, parentRecord, level);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    },
    onExpand: function onExpand(expanded, record) {
      var _iterator3 = _createForOfIteratorHelper(plugins),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _plugin$onExpand;

          var plugin = _step3.value;
          plugin === null || plugin === void 0 ? void 0 : (_plugin$onExpand = plugin.onExpand) === null || _plugin$onExpand === void 0 ? void 0 : _plugin$onExpand.call(plugin, expanded, record);
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    },

    /**
     * 暂时只做 components 的 deepmerge
     * 不处理自定义组件的冲突 后定义的 Cell 会覆盖前者
     */
    mergeComponents: function mergeComponents() {
      var deepMerge = function deepMerge() {
        for (var _len = arguments.length, componentsArray = new Array(_len), _key = 0; _key < _len; _key++) {
          componentsArray[_key] = arguments[_key];
        }

        var mergeResult = {};
        componentsArray = componentsArray.filter(Boolean);
        componentsArray.forEach(function (components) {
          var componentsKeys = Object.keys(components);

          var _loop = function _loop() {
            var componentKey = _componentsKeys[_i];
            var value = components[componentKey];

            if (typeof value === 'function') {
              // cell: Function
              mergeResult[componentKey] = value;
            } else if (_typeof(value) === 'object') {
              // body: { row: Function }
              mergeResult[componentKey] = deepMerge.apply(void 0, _toConsumableArray(componentsArray.map(function (object) {
                return object[componentKey];
              })));
            }
          };

          for (var _i = 0, _componentsKeys = componentsKeys; _i < _componentsKeys.length; _i++) {
            _loop();
          }
        });
        return mergeResult;
      };

      var allComponents = [props.components].concat(_toConsumableArray(plugins.map(function (plugin) {
        return plugin.components;
      })));
      return deepMerge.apply(void 0, _toConsumableArray(allComponents));
    }
  };
  return container;
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "/* .react-antd-treetable .ant-table-tbody > tr > td {\r\n  border-bottom-color: transparent;\r\n} */\r\n\r\n.react-antd-treetable-cell {\r\n  position: relative;\r\n}\r\n\r\n.react-antd-treetable-cell-content {\r\n  display: flex;\r\n}\r\n\r\n.react-antd-treetable-filter-cell {\r\n  display: flex;\r\n  align-items: center;\r\n}\r\n";
styleInject(css_248z);

var _excluded$1 = ["columns", "dataSource", "rowKey", "indentSize", "childrenColumnName", "onExpand"];
var TreeTable = /*#__PURE__*/React.forwardRef(function (rawProps, ref) {
  var _props$expandable;

  var props = resolveProps(rawProps);

  var columns = props.columns,
      dataSource = props.dataSource,
      rowKey = props.rowKey,
      indentSize = props.indentSize,
      childrenColumnName = props.childrenColumnName,
      onExpandProp = props.onExpand,
      restProps = _objectWithoutProperties(props, _excluded$1);

  var _useReducer = useReducer(function (x) {
    return x + 1;
  }, 0),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      _ = _useReducer2[0],
      forceUpdate = _useReducer2[1];

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      internalExpandedRowKeys = _useState2[0],
      setInternalExpandedRowKeys = _useState2[1];

  var expandedRowKeys;
  var setExpandedRowKeys;

  if ('expandedRowKeys' in props) {
    // ant-design v3
    expandedRowKeys = props.expandedRowKeys;
    setExpandedRowKeys = props.onExpandedRowsChange;
  } else if ('expandable' in props && ((_props$expandable = props.expandable) === null || _props$expandable === void 0 ? void 0 : _props$expandable.expandedRowKeys)) {
    // ant-design v4
    expandedRowKeys = props.expandable.expandedRowKeys;
    setExpandedRowKeys = props.expandable.onExpandedRowsChange;
  } else {
    expandedRowKeys = internalExpandedRowKeys;
    setExpandedRowKeys = setInternalExpandedRowKeys;
  }

  var replaceChildList = function replaceChildList(record, childList) {
    record[childrenColumnName] = childList;
    record[INTERNAL_IS_LOADING] = false;
    rewriteTree({
      dataSource: childList,
      parentNode: record
    });
  };

  var setNodeLoading = function setNodeLoading(record, isLoading) {
    if (record) {
      record[INTERNAL_IS_LOADING] = isLoading;
      forceUpdate();
    }
  };

  var getNodeLoading = function getNodeLoading(record) {
    return record === null || record === void 0 ? void 0 : record[INTERNAL_IS_LOADING];
  };

  var getParentRecord = function getParentRecord(record) {
    return record === null || record === void 0 ? void 0 : record[INTERNAL_PARENT];
  };

  var getRecordLevel = function getRecordLevel(record) {
    return record === null || record === void 0 ? void 0 : record[INTERNAL_LEVEL];
  };

  var nodeUtils = {
    setNodeLoading: setNodeLoading,
    getNodeLoading: getNodeLoading,
    getParentRecord: getParentRecord,
    getRecordLevel: getRecordLevel
  };
  var handlers = {};

  var addImperativeHandle = function addImperativeHandle(pluginHandlers) {
    handlers = Object.assign(handlers, pluginHandlers);
  };

  var pluginContext = _objectSpread2({
    forceUpdate: forceUpdate,
    replaceChildList: replaceChildList,
    expandedRowKeys: expandedRowKeys,
    setExpandedRowKeys: setExpandedRowKeys,
    addImperativeHandle: addImperativeHandle
  }, nodeUtils);

  var pluginContainer = usePluginContainer(props, pluginContext);
  useImperativeHandle(ref, function () {
    return _objectSpread2(_objectSpread2({
      replaceChildList: replaceChildList
    }, nodeUtils), handlers);
  });
  var rewrittenColumns = columns.map(function (rawColumn) {
    var column = Object.assign({}, rawColumn);
    pluginContainer.onColumn(column);
    return column;
  }); // hack: 解决 antd v4 一个奇怪的问题
  // 只有一个节点且异步加上 children 的时候 无法显示展开按钮
  // 所以处理完所有节点后 再开始渲染表格组件

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      ready = _useState4[0],
      setReady = _useState4[1];

  useEffect(function () {
    rewriteTree({
      dataSource: dataSource
    });
    setReady(true); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [dataSource]);
  /**
   *  需要对 dataSource 进行一些改写 增加层级、父节点、loading 节点、分页等信息
   */

  function rewriteTree(_ref) {
    var _ref$dataSource = _ref.dataSource,
        dataSource = _ref$dataSource === void 0 ? [] : _ref$dataSource,
        _ref$parentNode = _ref.parentNode,
        parentNode = _ref$parentNode === void 0 ? null : _ref$parentNode;
    // 在动态追加子树节点的时候 需要手动传入父节点的 level 否则 level 会从 1 开始计算
    var startLevel = (parentNode === null || parentNode === void 0 ? void 0 : parentNode[INTERNAL_LEVEL]) || 0;

    if (parentNode) {
      pluginContainer.onRecord(parentNode, null, startLevel);
    }

    traverseTree(dataSource, childrenColumnName, function (node, parent, level) {
      parent = parent || parentNode || node[INTERNAL_PARENT]; // 记录节点的层级

      node[INTERNAL_LEVEL] = level + startLevel; // 记录节点的父节点

      node[INTERNAL_PARENT] = parent;
      pluginContainer.onRecord(node, parent, level);
    });
    forceUpdate();
  }

  var onExpand = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(expanded, record) {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              pluginContainer.onExpand(expanded, record);
              onExpandProp === null || onExpandProp === void 0 ? void 0 : onExpandProp(expanded, record);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function onExpand(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  var components = pluginContainer.mergeComponents();
  var defaultTableProps = {
    pagination: false
  };

  if (!ready) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "react-antd-treetable"
  }, /*#__PURE__*/React.createElement(Table, _objectSpread2(_objectSpread2(_objectSpread2({}, defaultTableProps), restProps), {}, {
    childrenColumnName: childrenColumnName,
    indentSize: indentSize,
    columns: rewrittenColumns,
    components: components,
    rowKey: rowKey,
    dataSource: dataSource,
    onExpand: onExpand,
    expandIcon: function expandIcon(expandIconProps) {
      return /*#__PURE__*/React.createElement(TreeTableExpandIcon, _objectSpread2(_objectSpread2({}, expandIconProps), {}, {
        expandIcon: props.expandIcon
      }));
    },
    expandedRowKeys: expandedRowKeys,
    onExpandedRowsChange: setExpandedRowKeys
  })));
});
function resolveProps(props) {
  var disableIndentLine = props.disableIndentLine,
      _props$indentSize = props.indentSize,
      indentSize = _props$indentSize === void 0 ? 24 : _props$indentSize,
      _props$childrenColumn = props.childrenColumnName,
      childrenColumnName = _props$childrenColumn === void 0 ? 'children' : _props$childrenColumn,
      columns = props.columns,
      headDataIndex = props.headDataIndex,
      _props$plugins = props.plugins,
      userPlugins = _props$plugins === void 0 ? [] : _props$plugins;

  if (!headDataIndex) {
    var _columns$;

    headDataIndex = (_columns$ = columns[0]) === null || _columns$ === void 0 ? void 0 : _columns$.dataIndex;
  }

  var plugins = [].concat(_toConsumableArray(userPlugins), [disableIndentLine ? null : useIndentLinePlugin]);
  return _objectSpread2(_objectSpread2({}, props), {}, {
    plugins: plugins,
    indentSize: indentSize,
    headDataIndex: headDataIndex,
    childrenColumnName: childrenColumnName
  });
}

export default TreeTable;
export { resolveAllExpandableKeys, traverseTree, useEmptyPlugin, useFilterPlugin, useIndentLinePlugin, useLazyloadPlugin, usePaginationPlugin, usePluginContainer };
