import { PopoverProps } from 'antd';
import { TreeTablePlugin } from '../types';
interface UseFilterPlugin<RecordType = any> {
    (onFetch: OnFetch<RecordType>, options?: {
        /** 展示过滤的列的 dataIndex */
        filterDataIndex?: string;
        /** 覆盖 popover 的默认 props */
        popover?: PopoverProps;
        /** 过滤输入框的 placeholder */
        placeholder?: string;
        /** 根据行信息决定是否开启过滤 */
        enable?(record: RecordType): boolean;
        /** 有筛选值时图标的颜色 */
        highlightIconColor?: string;
    }): TreeTablePlugin;
}
interface OnFetch<RecordType = any> {
    (record: RecordType, value: string): any;
}
export declare const useFilterPlugin: UseFilterPlugin;
export {};
