import { TableColumnType } from 'antd';
import { ResolvedProps, TreeTablePluginContext } from '../types';
export declare const usePluginContainer: <RecordType extends object = any>(props: ResolvedProps, context: TreeTablePluginContext) => {
    onColumn(column: TableColumnType<RecordType>): void;
    onRecord(record: RecordType, parentRecord: RecordType, level: number): void;
    onExpand(expanded: boolean, record: RecordType): void;
    /**
     * 暂时只做 components 的 deepmerge
     * 不处理自定义组件的冲突 后定义的 Cell 会覆盖前者
     */
    mergeComponents(): {};
};
export { usePaginationPlugin } from './pagination';
export { useLazyloadPlugin } from './lazyload';
export { useIndentLinePlugin } from './indent-line';
export { useFilterPlugin } from './filter';
export { useEmptyPlugin } from './empty';
